/***************************************************************************
 * PROGRAM: GetSet.cmd - OBJECTively one hell of a script.
 *          Copyright 1997 John B. Stein.  All Rights Reserved.
 *
 * PURPOSE: List Object info - Class, Title, Setup String of Objectid's
 *          Open, Delete, Create Script to duplicate Object
 *
 * VERSION: 1.75
 *
 * FILES  : REQUIRES WPTOOLS.DLL and REXXUTIL.DLL libraries.
 *          WPTools.DLL uses WptoolsQueryObject() to get settings.
 *          WPTools19.ZIP is Freeware. Thanks to Henk Kelder
 *
 * SYNTAX:  GetSet [-qQ] [-hH] [Object_ID]  (parameters are optional)
 *                No parameters - Interactive Menu Mode
 *
 * WRITTEN: 12/20/96 by Jack Stein
 *          Jack's Free Lunch BBS
 *          FidoNet:   1:129/171
 *          BBS Phone: 1-412-492-0822
 *          EMAIL:     JBSTEIN@bellatlantic.net
 ****************************************************************************
 *******  NOTICE!   NOTICE!   NOTICE!   NOTICE!   NOTICE!   NOTICE!  *******
 ***************************************************************************
 * This script may:
   *** be modified for PERSONAL use only!
   *** NOT be SOLD or REPRODUCED in profit ventures without prior
       written consent of the author.
   *** be freely distributed as long as source is UNMODIFIED!
   *** Work on my system, NO OTHER GUARANTEES!
   *** be USED at your OWN risk.
 ***************************************************************************
 * Please let me know what you think. Advise of any neat changes
 * improvements suggestions and so on.
 ***************************************************************************
 ***************************************************************************/
/* Get Version */
Version = sourceline(8)
parse value Version with junk ":" Ver

/* set default Output Device */
OD  = "con"
/* get default directory, strip Trailing "\"  */
DIR = strip(directory(),"T","\")
/* set up color VARS */
call Init_Colors
/* Load REXXUTIL.DLL and WPTOOLS.DLL Function Libraries */
call Load_Util_Functions
/* Get command line parameters, if any */
parse arg cmdline
call Get_Params

/* Run menu unless OBJECTID passed on the Command line */
do forever
   if obj \= "" | obj == "No Object Selected" then call Show_Menu
end

call Get_Out
/***************************************************************/
Show_Menu:
call syscls
call syscurstate 'on'
row = 1
/* Note: Obj_Len isn't really needed now, was using for putting
 *       objectid in a box, now box ONLY used for "No Object Selected"*/
Obj_Len = length(obj)
Obj_Len = Obj_Len + 2

call Show_Credits
rc = lineOUT(con,"")
rc = lineOUT(con,bred "      Ŀ")
rc = lineOUT(con,     "       "bwhite"    OS2 OBJECT MENU"bred"    ")
rc = lineOUT(con,bred "      ")
rc = lineOUT(con,bred "      Ŀ")
rc = lineOUT(con,bred "      "bcyan" 1 "byellow"-"bcyan "S"byellow"how Settings"bred"     ")
rc = lineOUT(con,bred "      "bcyan" 2 "byellow"-"bcyan "O"byellow"pen Object"bred"       ")
rc = lineOUT(con,bred "      "bcyan" 3 "byellow"-"bcyan "D"byellow"elete Object"bred"     ")
rc = lineOUT(con,bred "      "bcyan" 4 "byellow"-"bcyan "N"byellow"ew Object Number"bred" ")
rc = lineOUT(con,bred "      "bcyan" 5 "byellow"-"bcyan "L"byellow"ist Objects"bred"      ")
rc = lineOUT(con,bred "      "bcyan" 6 "byellow"-"bcyan "F"byellow"ind an Object"bred"    ")
rc = lineOUT(con,bred "      "bcyan" 7 "byellow"-"bcyan "C"byellow"reate CMD File"bred"   ")
rc = lineOUT(con,bred "      "bcyan" H "byellow"-"bcyan "H"byellow"ELP"bred"              ")
rc = lineOUT(con,bred "      "bcyan" Q"byellow "to Quit "bred"")
rc = lineOUT(con,bcyan)
rc = lineOUT(con,     "         Make Selection ==>"bwhite)
/* set column for object info for easy manipulation */
col = 38
/* show object info if one selected */
if obj \= "No Object Selected" then
   do
      rc = syscurpos(row + 7,col+5)
      rc = lineOUT(con,bred "Current Object No."bcyan Obj_Num )
      rc = syscurpos(row + 9,col)
      rc = lineOUT(con,byellow 'ObjectID :'bcyan Obj)
      rc = syscurpos(row + 10,col)
      rc = lineOUT(con,byellow 'Classname:'bcyan Class)
      rc = syscurpos(row + 11,col)
      rc = lineOUT(con,byellow 'Title    :'bcyan Title)
      rc = syscurpos(row + 12,col)
      rc = lineOUT(con,byellow 'Location :'bcyan Location)
   end
else
   do
      rc = syscurpos(row + 8,col+4)
      rc = lineOUT(con,bred ""copies("",Obj_Len)"")
      rc = syscurpos(row + 9,col+4)
      rc = lineOUT(con,bred ""bgblue||bcyan Obj bgblack||bred"")
      rc = syscurpos(row + 10,col+4)
      rc = lineOUT(con,bred ""copies("",Obj_Len)"")
   end

rc = syscurpos(15,28)
Choice = translate(sysgetkey("NOECHO"))
select
   when Choice = 1 | Choice = "S" then
      do
         call Show_Settings
         if obj \= "No Object Selected" then
            do
               say bred|| copies('',40)
               rc = lineOUT(con,bwhite"  END of List!  Press any key...")
               rc = sysgetkey("NoEcho")
            end
         if quiet = 1 then call Init_Colors
      end
   when Choice = 2 | Choice = "O" then call Open_Object
   when Choice = 3 | Choice = "D" then call Delete_Object
   when Choice = 4 | Choice = "N" then
      do
         if IDList.0 = "IDList.0" then call List_Objects
         else call Get_New_Selection
         return
      end
   when choice = 5 | Choice = "L" then call List_Objects
   when choice = 6 | Choice = "F" then call Find_Obj
   when choice = 7 | Choice = "C" then call Write_Settings
   when translate(choice)   = 'H' then call Help
   when translate(choice)   = 'Q' then call Get_Out
   otherwise nop
   end
return  /* Emd Show_Menu */
/***************************************************************/
Write_Settings:
 /* Check for Object */
 if obj = "No Object Selected" then
   do
      call No_Object
      return
   end
 /* Select default Path and Filename */
 OD = strip(obj,"B","<")
 OD = strip(OD,"B",">")||".cmd"
 if length(OD) > 12 then OD = right(OD,12)
 OD = DIR"\"OD
 /* Ask User if Default OutPut File is OK */
 do forever
    rc = syscls()
    rc = syscurpos(4,0)
    rc = lineout(con,byellow center("CURRENT OBJECT",78))
    rc = syscurpos(5,0)
    rc = lineout(con,bcyan center(obj,78))
    rc = syscurpos(9,0)
    rc = lineout(con,byellow center("OutPut File",78))
    rc = syscurpos(10,0)
    rc = lineOUT(con,bcyan center(OD ,78))
    rc = lineOUT(con,byellow center("Use This Filename? (Y/n):",78))
    rc = syscurpos(11,53)
    Choice = sysgetkey("NoEcho")
    /* If not, Get user filename */
    if translate(Choice) == "N" then
       do
          rc = syscurpos(12,0)
          rc = lineOUT(con,byellow center("Enter New Filename",78))
          rc = syscurpos(13,30)
          rc = lineOUT(con,bcyan "===>")
          rc = syscurpos(13,35)
          pull OutFIle
          OD = DIR"\"OutFile
       end

    if stream(OD,"C","OPEN") == "READY:" then
       do
          call Init_No_Colors
          call Make_Obj_Cmd
          call Init_Colors
          rc = syscls()
          rc = syscurpos(10,0)
          if stream(OD,"C","Close") == "READY:" then
             do
                rc = lineOUT(con,center("SETTINGS written to" OD,80))
                rc = lineout(con,bwhite center(Press Any Key....,80))
                rc = sysGetKey("NoEcho")
                leave
             end
          else  /* unable to close file */
             do
                rc = lineOUT(con,center('ERROR Closing file' OD,80))
                rc = lineout(con,bwhite center(Press Any Key....,80))
                rc = lineout(con,bred center("(Q for Menu)",80))
                if translate(sysGetKey("NoEcho")) == "Q" then leave
             end
       end
    else /* unable to Open File */
       do
          rc = syscurpos(12,0)
          rc = lineout("stderr",bred center(" ERROR Opening file ",80))
          rc = syscurpos(13,0)
          rc = lineout(con,bwhite center("  Press Any Key  ",80))
          rc = syscurpos(14,0)
          rc = lineout(con,bred center("(Q to Quit)",80))
          rc = syscurpos(15,40)
          if translate(sysGetKey("NoEcho")) == "Q" then leave
       end
 end
OD = "con"
return  /* End Write_Settings */
/*****************************************************/
Make_Obj_Cmd:
Line = '/************************************************/'
if Obj = "No Object Selected" then
   do
      call No_Object
      return
   end
row = 0
call syscurstate 'off'
if quiet = 1 then call Init_No_Colors

rc = lineOUT(OD,"/"|| copies('*',60))
rc = lineOUT(OD,' ** Rexx Script to Create ObjectID:' Obj)
rc = lineOUT(OD,' ** Created via GetSet.Cmd  Version' Ver )
rc = lineOUT(OD," ** by Jack Stein - Jack's Free Lunch BBS 1:129/171")
rc = lineOUT(OD,' **')
rc = lineOUT(OD,' ** NOTE: This duplicates' obj)
rc = lineOUT(OD,' **')
rc = lineOUT(OD,' ** Edit "OBjectID" VAR if you want new objectID')
rc = lineOUT(OD,' ** Edit "Loc" VAR to place object in different folder')
rc = lineOUT(OD,' ** The "TITLE" setting should match the NAME VAR.')
rc = lineOUT(OD,' ** "Loc" must be an existing FOLDER ObjectID')
rc = lineOUT(OD,' **')
rc = lineOUT(OD,' ** IF you know legal settings for objects, you can')
rc = lineOUT(OD,' ** add any you want, use this as a template etc.')
rc = lineOUT(OD,' ** Make SURE you are familar with settings and how')
rc = lineOUT(OD,' ** OBJECTS work.  See WPTools19.ZIP for more information')
rc = lineOUT(OD," "|| copies('*',59)|| "/")
rc = lineOUT(OD,'/***  Load Rexx Utilities  ***/')
rc = lineOUT(OD,"call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'")
rc = lineOUT(OD,'call SysLoadFuncs')
rc = lineOUT(OD,line)
rc = lineOUT(OD,'/***  Setup Strings  ***/')
rc = lineOUT(OD,'Type  = "'|| Class||'"')
rc = lineOUT(OD,'Name  = "'|| Title||'"')
rc = lineOUT(OD,'Loc   = "'|| Location||'"')
rc = lineOUT(OD, Line)
rc = lineOUT(OD,'/***  Setup Options Strings  ***/')
rc = lineOUT(OD,'Options =,')

do x = 1 to Sindx - 2
   if pos("DOS_DEVICE",setup.x) \= 0 then
      /* change ","'s to LineFeed ('0a'x) */
      do until string2 == ""
         parse value setup.x with string1 "," string2
         setup.x =string1"'||'0A'x||'"string2
      end
      rc = lineOUT(OD,"         '" || setup.x || ";'||,")
end

rc = lineOUT(OD,"         '" || setup.x || ";'")
rc = lineOUT(OD,Line)
rc = lineOUT(OD,'/***  Create Object ***/')
rc = lineOUT(OD,' ')
rc = lineOut(OD,"Rcode = SysCreateObject(type,name,loc,options,'U')")
rc = lineOUT(OD,' ')
rc = lineOut(OD,'if Rcode = 1 then say name||" created in: "loc')
rc = lineOut(OD,'else say name||" *not* created."')
rc = lineOUT(OD,' ')
rc = lineOUT(OD,'/**************  End of Script  **************/')
return /* End Make_Obj_Cmd */
/***************************************************************/
Get_New_Selection:
obj = ''
call syscurstate 'on'
do forever
   rc = syscurpos(15,7)
   rc = lineOUT(con,bwhite"Enter a NUMBER for Object:")
   rc = syscurpos(16,7)
   rc = lineOUT(con,bred "  (1 to" Obj_Count") ===>          ")
   rc = syscurpos(16,26)
   pull Obj_Num
   if datatype(Obj_Num) = "NUM" & Obj_Num <= Obj_Count then
      do
         obj =  IDList.Obj_Num
         call Get_Obj_Settings
         leave
      end
 end /*do forever */
call syscurstate 'off'
return  /* End Get_New_Selection */
/*****************************************************/
Show_Settings:
if Obj = "No Object Selected" then
   do
      call No_Object
      return
   end
row = 0
call syscurstate 'off'
if quiet = 1 then call Init_No_Colors
if OD = "con" then call Show_Credits

rc = lineOUT(OD,bred|| copies('',45))
rc = lineOUT(OD,byellow 'ObjectID :'bcyan Obj)
rc = lineOUT(OD,byellow 'Classname:'bcyan Class)
rc = lineOUT(OD,byellow 'Title    :'bcyan Title)
rc = lineOUT(OD,byellow 'Location :'bcyan Location)
rc = lineOUT(OD,byellow 'Setup Strings:')
rc = lineOUT(OD,bred|| copies('',45))

do x = 1 to Sindx - 1
   rc = lineOUT(OD,bcyan||right(x,2)' 'byellow setup.x bwhite)
   if x//17 = 0 & quiet \= 1 & OD == "con" then
      do
         pause
         call Show_Credits
         rc = lineOUT(OD, bred|| copies('',45))
         rc = lineOUT(OD, byellow 'ObjectID  :'bcyan Obj)
         rc = lineOUT(OD, byellow 'Classname :'bcyan Class)
         rc = lineOUT(OD, byellow 'Title     :'bcyan Title)
         rc = lineOUT(OD, byellow 'Location  :'bcyan Location)
         rc = lineOUT(OD, byellow 'Setup Strings:')
         rc = lineOUT(OD, bred|| copies('',45))
      end
end
return /* End Show_Settings */
/************  List ObjectIds  *****************/
List_Objects:
obj = ""
rc = syscls()
row = 0
App='PM_Workplace:Location'
call sysIni 'USER', App, 'All:','IDList'
if Result == 'ERROR:' then
   do
      rc = lineout(Stderr, 'Error querying for' App)
      call Get_Out
   end
Obj_Count = IDList.0
row = 2
col = 1
rc = lineOUT(con,bcyan center(Obj_Count bred||,
            "ObjectID's in USER.INI File",84))
rc = lineOUT(con,center(copies("",33),78))

do i = 1 to IDList.0 until obj \= ""
   rc = syscurpos(row,col)
   rc = lineOUT(OD,bcyan right(i,3) byellow IDList.i)
   select
      when i == IDList.0 then call Get_List_Selection
      when row//21 == 0 & col \= 41 then
         do
            row = 1; col = 41
         end
      when row//21 == 0 & col == 41 then
         do
            call Get_List_Selection
            rc = syscls()
            rc = lineOUT(con,bcyan center(Obj_Count bred||,
                        "ObjectID's in USER.INI File",84))
            rc = lineOUT(con,center(copies("",33),78))
            row =1; col = 0
         end
       otherwise nop
   end /* select */
   row = row + 1
end /* do i = 1 to Obj_Count */
/* if selection made */

if obj \= "" then call Get_Obj_Settings
else call No_Object

return obj /*End List_Objects */
/*****************************************************/
Get_List_Selection:
 rc = syscurpos(22,22)
 rc = lineOUT(con,bred"(1 to "Obj_Count")")
/* rc = syscurpos(23,7)*/
 rc = syscurpos(23,1)
 if IDList.0 - i > 0 then
   rc = lineOut(con,bgcyan bgreen"   (Q to Quit)    "bblue,
                "Enter choice ==>    ",
                 green "(<Enter> to Page)    "bgblack bwhite)
 else
   rc = lineOut(con,bgcyan bgreen"   (Q to Quit)    "bblue,
                "Enter choice ==>    ",
                 green "(Enter to Menu)   "bgblack bcyan)
 do forever
   rc = syscurpos(23,37)
   pull choice
   select
      when datatype(Choice) = "NUM" then
         if Choice < 1 | Choice > IDList.0 then iterate
         else
            do
               obj = IDList.choice
               Obj_Num = choice
               return
            end
      when choice == "" then leave
      when translate(choice) == "Q" then call Get_Out
      otherwise nop
   end /* select */
 end   /* do forever */
return  /* End Get_List_Selection */
/*******************************************************/
Get_Obj_Settings:
if obj = "No Object Selected" then return
rc = syscurpos(24,1)
/*rc = lineOUT('con', byellow||"Looking up:"bcyan obj)*/
RC = WPToolsQueryObject(obj,,
                       "Class",,
                       "Title",,
                       "SetupString",,
                       "Location")
if RC <> 1 then
   do
      rc = syscls()
      rc = syscurpos(10,0)
      rc = lineOUT(stderr,center('Unable to return object settings for',80))
      rc = lineOUT(stderr,byellow center('<'obj'>',80))
      rc = lineOUT(stderr,bwhite center('Press Any Key...',80))
      rc = sysgetkey('NOECHO')
      Obj = "No Object Selected"
   end
else
   do
      Sindx = 1
      do while setupstring \= ""
         parse value setupstring with setup.Sindx ';' setupstring
         Sindx = Sindx + 1
      end
   end
return  /* End Get_Obj_Settings */
/*****************************************************/
Find_Obj:
obj = ""
choice =""
   rc = syscls()
   rc = syscurpos(4,10)
   rc = lineOut(con,bred "Note: lower case strings will also check",
                         "UPPER case")
   rc = syscurpos(5,17)
   rc = lineOut(con,"UPPER case strings match UPPER case ONLY")
   rc = syscurpos(6,17)
   rc = lineOut(con,"MiXeD case strings should be entered in Mixed Case!")
   rc = syscurpos(10,0)
   rc = lineOut(con,bcyan center("Enter any part of object string to find:",78))
   rc = syscurpos(11,30)
   rc = lineOUT(con,"===>")
   rc = syscurpos(11,35)
   parse pull Target
   Targindex = 1
   /* Search list of ObjectID'S for Targets, assign matches to Targ.targindex */
   do IDindex = 1 to IDList.0
    if pos(Target,IDList.IDindex) <> 0 then
      do
         Targ.Targindex    = IDList.IDindex
         ListNum.Targindex = IDindex
         Targindex         = Targindex + 1
      end
    else
      if pos(translate(Target),IDList.IDindex) <> 0 then
         do
            Targ.Targindex    = IDList.IDindex
            ListNum.Targindex = IDindex
            Targindex         = Targindex + 1
         end
   end
   /* check for match*/
   Targ.0 = Targindex - 1
   if Targ.0 < 1 then
      do
         rc = syscurpos(10,0)
         rc = lineOUT(con,center(byellow"No ObjectID Match found for",86))
         rc = lineOUT(con,center(bwhite Target,84))
         rc = lineOUT(con,center(bcyan"Look Up Another Y/n?",84))
         rc = syscurpos(12,48)
         Choice = sysgetkey("NoEcho")
         if translate(Choice) == "N" then
            do
               obj = No_Object()
               return
            end
         else call Find_obj
      end  /* if Targ.0 < 1 */

rc = syscls()
row = 1
col = 1
rc = lineOUT(con,bred center("Search Target:" bcyan||Target,
                 bred"("Targ.0 "Matches Found)",90))

/* Show hits on screen for selection*/
do num = 1 to targ.0
   rc = syscurpos(row,col)
   rc = lineout(con,bcyan||right(num,3) "-" byellow ||Targ.num)
   select
      when num == targ.0 then call Get_Find_Selection
      when row // 21 == 0 & col \= 41 then
         do
            row =  0
            col = 41
         end
      when row // 21 == 0 & col == 41 then
         do
            call Get_Find_Selection
            rc = syscls()
            rc = lineOUT(con,bred center("Search Target:" bcyan||Target,
                 bred"("Targ.0 "Matches Found)",90))
            row = 0
            col = 0
         end
      when num > targ.0 & obj = "" then call No_Object
      otherwise nop
   end /*select */
   if obj \= "" then
         do
            call Get_Obj_Settings
            leave
         end
   row = row + 1
end

if obj == "" then obj = "No Object Selected"
return /* End Find_Obj */
/*****************************************************/
Get_Find_Selection:
 rc = syscurpos(22,25)
 rc = lineOUT(con,bred"(1 to "targ.0")")
 rc = syscurpos(23,22)
 if targ.0 - num > 0 then
   rc = lineOut(con,bcyan||"Enter choice ==>    "bred"(Enter to Page)"bcyan)
 else
   rc = lineOut(con,bcyan||"Enter choice ==>    ")
 do forever
   rc = syscurpos(23,38)
   pull choice
   select
      when datatype(Choice) = "NUM" then
      if Choice < 1 | Choice > Targ.0 then iterate
      else
         do
            Obj_Num = ListNum.choice
            obj = Targ.choice
            return
         end
      when choice == "" then return
      otherwise nop
   end /* select */
 end   /* do forever */
return /* End Find_Obj */
/*****************************************************/
No_Object: procedure expose Obj Bred Bwhite
 obj  = "No Object Selected"
 rc   = syscurstate('Off')
 rc   = syscls()
 rc   = syscurpos(10,0)
 rc   = lineout(con,bred   center("No Object Selected",76))
 rc   = lineout(con,bwhite center("Press Any Key...",79))
 junk = sysgetkey("NoEcho")
 return obj  /* End No_Object */
/*****************************************************/
OPEN_OBJECT: procedure expose Obj Bred Bwhite
if obj = "No Object Selected" then obj = No_Object()
else
   do
      rc = lineOUT(con, ".......opening" obj)
      if sysopenobject(obj,0,1) then return
      else
         do
            rc = lineOUT(stderr,bred"    Problem opening" obj)
            rc = lineOUT(con,bwhite "Press Any Key...")
            rc = sysgetkey('NoEcho')
         end
   end
return  /* End Open_Object */
/*****************************************************/
Delete_Object:
if obj = "No Object Selected" then call No_Object
else
   do
      RC = WPToolsQueryObject(obj,"Class","Title",,"Location")
      rc = syscls()
      rc = syscurpos(2,26)
      rc = lineOUT(con,byellow 'ObjectID :'bcyan Obj)
      rc = syscurpos(3,26)
      rc = lineOUT(con,byellow 'Classname:'bcyan Class)
      rc = syscurpos(4,26)
      rc = lineOUT(con,byellow 'Title    :'bcyan Title)
      rc = syscurpos(5,26)
      rc = lineOUT(con,byellow 'Location :'bcyan Location)
      if pos("FOLDER",translate(CLASS)) \= 0 then
         do
            rc = syscurpos(8,0)
            rc = lineOUT(con,bred center("WARNING: Classname = "class,78))
            rc = lineOUT(con,center("you will DELETE all objects in the FOLDER",80))
         end
      rc = syscurpos(13,0)
      rc = lineOUT(con,center(byellow"Are you SURE you want to delete:",86))
      rc = lineOUT(con, "")
      rc = lineOUT(con,bcyan center(obj,72))
      rc = lineOUT(con,byellow)
      rc = lineOUT(con,center("Select y/N?",74))
      rc = syscurpos(17,43)
      Choice = sysgetkey("NOECHO")
      if translate(Choice) = 'Y' then
         do
            rc = syscurpos(19,0)
            rc = lineOUT(con,center("....Deleting" obj,74))
            rc = lineOUT(con, "")
            if SysDestroyObject(obj) = 1 then
               rc = lineOut(con,center(obj 'destroyed',74))
            else
               do
                  rc = syscurpos(19,36)
                  rc = lineOUT(stderr,bred center('ERROR' obj 'NOT Destroyed',80))
               end
            rc = lineOut(con,bwhite center("Press Any Key for Menu",73))
            Junk = sysgetkey('NoECHO')
         end
   end
return /* End Delete_Object */
/***************************************************************/
Show_Credits: procedure expose Bblue row ver
col = 45

call sysCls
rc = syscurpos(row,col)
rc = lineOUT(con, bblue"Ŀ")
rc = syscurpos(row+1,col)
rc = lineOUT(con,      ' GETSET COMMAND ')
rc = syscurpos(row+2,col)
rc = lineOUT(con,      '       By       ')
rc = syscurpos(row+3,col)
rc = lineOUT(con,      '   Jack Stein   ')
rc = syscurpos(row+4,col)
rc = lineOUT(con,      '   1:129/171    ')
rc = syscurpos(row+5,col)
rc = lineOUT(con,      '   Ver.'Ver'    ')
rc = syscurpos(row+6,col)
rc = lineOUT(con,      "")
rc = syscurpos(0,0)
return
/*****************************************************
FUNCTION: Get_Params
 1) Called from Main Routine to check commandline parameters
 2) Calls List_Objects if no Object ID given on CommandLine
 3) checks for switches and calls appropriate routines
*****************************************************/
Get_Params:
 n   = 0    /* set index to 0 */
 obj = ""   /* init object id */
 do while cmdline \= ""
   parse var cmdline A_param cmdline
   A_param = strip(A_param,'B','"')
   select
      when pos(substr(A_Param,1,1), '<')  \ = 0 then obj = A_Param
      /* when switch is found.
        Note: bad switch (other than /-) will be passed as an ObjectID. */
      when pos(substr(A_param,1,1), '/-') \= 0 then
         do
            n = n + 1
            Switch.0 = n
            Switch.n = substr(A_param,2)
            if translate(Switch.n) = "Q" then quiet = 1
            else
               if Switch.n = "?" | translate(Switch.n) = 'H' then call Help
               else
                  do
                     rc = lineOUT(Stderr, "ERROR : Unknown switch:" A_param)
                     pause
                     call Help
                  end
         end
      otherwise obj = "<"||A_Param||">"  /* Object passed */
    end  /*select*/
end /*do*/
if obj = "" then  obj = List_Objects()   /* No Object Passed */
else  /* obj passed, assumed to be writing to a file */
   do
      call Get_Obj_Settings
      OD = "stdout"  /* added so redirection works in show settings */
      call Show_Settings
      call Get_out
   end
return  /* End Get_Params */
/****************************************************
 * FUNCTION: Init_Colors
 * 1) Initialize ANSI Colors VARS
 * 2) Called from Get_Params or Help Functions
 * 4) Returns nothing
 * NOTE: All Colors are not used
*****************************************************/
Init_Colors:

GRY_BLK = '1B'x || '[0;37;40m'
CYN_BLK = '1B'x || '[1;36;40m'
WHI_GRY = '1B'x || '[1;37;47m'
BLK_GRY = '1B'x || '[0;30;47m'
BLU_GRY = '1B'x || '[0;34;47m'
CLR_SCN = '1B'x || '[2J'
YEL_BLK = '1B'x || '[1;37;40m'
RED_BLK = '1B'x || '[1;31;40m'
GRN_BLK = '1B'x || '[1;32;40m'


  esc     = '1B'x          /* define ESCape character        */
  normal  = esc||"[0m"     /* resetting attributes to normal(attributes Off)*/
  bright  = esc||"[1m"     /* bright foreground colors       */
  DelEOL  = esc || '[K'    /* delete rest of the line        */
  SavePos = esc || '[s'    /* save the cursor position       */
  RestPos = esc || '[u'    /* restore the cursor position    */
  lastcolor = esc || '[2;m'
  blink     = esc || '[5;m'
  invers    = esc || '[7;m'
  invisible = esc || '[8;m'

  Black    = esc || '[30;m'  /* black foreground            */
  red      = esc || "[31m"   /* red foreground              */
  Green    = esc || '[32;m'
  Yellow   = esc || '[33;m'  /* yellow foreground           */
  Blue     = esc || '[34;m'
  Magenta  = esc || '[35;m'
  Cyan     = esc || '[36;m'
  White    = esc || '[37;m'

  bred     = bright || red     /* bright red foreground       */
  bgreen   = bright || Green
  byellow  = bright || yellow
  bblue    = bright || blue
  bMagenta = bright || Magenta
  bcyan    = bright || cyan
  bwhite   = bright || white
           /* define background color variables          */
  bgBlack     = esc || '[40;m'
  bgRed       = esc || '[41;m'
  bgGreen     = esc || '[42;m'
  bgYellow    = esc || '[43;m'
  bgBlue      = esc || '[44;m'
  bgMagnenta  = esc || '[45;m'
  bgCyan      = esc || '[46;m'
  bgWhite     = esc || '[47;m'
return
/*****************************************************/
Init_NO_Colors:
 rc = lineOUT(con,normal)
 normal  = ""
 blue    = ""
 red     = ""
 bblue   = ""
 bwhite  = ''
 bcyan   = ''
 byellow = ''
 bred    = ''
 bgcyan  = ''
 bgblack = ''
return
/***************************************************************/
Help:
if Quiet = 1 then call Init_Colors
call Show_Credits
say bwhite
say
say 'SYNTAX:'byellow 'GetSet' bcyan'[-qQ] [-hH] [Object_ID] '
say bwhite'WHERE:'
say byellow'  -q or Q      ' bcyan '= QUIET mode '
say byellow'  -h or H or ? ' bcyan '= Help'
say byellow'  Object_ID    ' bcyan '= ObjectID' bblue '(Case Sensitive)'
say byellow'  NO PARAMETERS' bcyan '= Interactive Menu Mode'
say
say byellow'  Example:' bcyan' getset'
say byellow'  Example:' bcyan' getset OPUS_BBS'
say byellow'  Example:' bcyan' getset /q OPUS_BBS >opus_set.dat'
say bred'                    |      |        |'
say '                    |      |        |____Output file'
say '                    |      |'
say '                    |      |_____ Object ID'
say bred'                    |'
say '                    |___ Quiet Switch'bcyan '("-" or "/" will work)'
say
say bblue center('Use /q when redirecting settings to file',79)
say bwhite
    pause
return
/*****************************************************/
Load_Util_Functions:
 call RxFuncDrop 'RexxUtil'
Function = 'REXXUTIL'
 call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
 call SysLoadFuncs

Function = WPTOOL
 call RxFuncAdd 'WPToolsLoadFuncs', 'WPTOOLS', 'WPToolsLoadFuncs'
 signal on Syntax Name Add_Function_Error
 call WPToolsLoadFuncs
/*WPT = WPToolsVersion()
rc = lineout(con,center('wptools version 'WPT' loaded',80))
pause */
signal off syntax
return
/*****************************************************/
Add_Function_Error:
   if rc = 43 then do
      say;say
      say "ERROR Loading "Function "Function Library"
      say
      say Function||'.DLL possibly not in DLL Path'
      exit
   end
signal off syntax
return
/*****************************************************/
Get_Out:
 call RxFuncDrop 'WPTOOLS'
 rc = lineout(con,normal)
 exit

